;    ...
;      

           #include <P16F628A.INC>
            LIST        p=16F628A    ; 
            __CONFIG    H'3F02'      ;  
                                    ; 
            
Sec         equ         0120h  ;
Sec0        equ         0121h   ; 
Sec1        equ         0122h   ;
scetbit     equ         0123h   ;
perem       equ         0124h    ;
Klast       equ         0125h
Prov1       equ         0126h    ;
SDcom       equ         0127h    ;
AdrHH       equ         0128h    ;
AdrHL       equ         0129h      ;
AdrLH       equ         012Ah     ; 
AdrLL       equ         012Bh       ;
firstklL    equ         012Ch
SDcrc       equ         012Dh     ;
firstklH    equ         012Eh
HH          equ         012Fh
HL          equ         0130h
LH          equ         0131h
LL          equ         0132h
FATH        equ         0133h
FATL        equ         0134h
rootH       equ         0135h
rootL       equ         0136h
datH        equ         0137h
datL        equ         0138h
zapLL       equ         0139h
zapLH       equ         013Ah
zapHL       equ         013Bh
namesec     equ         013Ch
kol2x       equ         013Dh
rsec0       equ         013Eh
rsec1       equ         013Fh
kolsek      equ         0140h
sizeLL      equ         0141h
sizeLH      equ         0142h
sizeHL      equ         0143h
sizeHH      equ         0144h
sheterr     equ         0145h
Sec2        equ         0146h
Sec3        equ         0147h
Sec4        equ         0148h

W_temp      equ         0079h
STATUS_temp equ         007Ah
FSR_temp    equ         007Bh
FSRtmp      equ         007Ch
shim45      equ         007Dh
flag        equ         007Eh
flag1       equ         007Fh


data1       equ         0020h



#DEFINE     stop  	PORTB,1
#DEFINE     next 	PORTB,2
#DEFINE     play  	PORTB,0
#DEFINE     back 	PORTB,4

#DEFINE     CS   	PORTA,2
#DEFINE     CLK  	PORTB,6
#DEFINE     DO  	PORTB,7
#DEFINE     DI  	PORTB,5

#DEFINE     din  	PORTB,3
#DEFINE     vdd  	PORTA,3
#DEFINE     sel  	PORTA,5
#DEFINE     ledres  	PORTA,0
#DEFINE     ledini  	PORTA,1




            org         0000h           ;      0 PC.
            goto        Start 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  
;     2-  3-  
;     

            org         0004h          
            
            btfss       INTCON,INTF
            goto        wavprer
            bcf         INTCON,INTE
            bcf         INTCON,INTF
            retfie

wavprer     movwf       W_temp          ;  STATUS  W
            swapf       STATUS,W
            bcf         STATUS,RP1
            movwf       STATUS_temp

            movf        FSR,W           ;   FSR,  
            movwf       FSR_temp        ;      
            movf        FSRtmp,W        ;
            movwf       FSR

            
            btfss       flag,2          ;    ,  =1
            goto        bnk3            ;   2- 
                                        ; =0,     3- 

            btfss       flag,3          ;    2-   
            goto        ustbnk2         ; =1,      
                                        ; =0,    ustbnk2,   
                                        ;  2- 




            
bnk2        btfsc       INDF,0          ; 2   (0  1 )   
            bsf         shim45,4        ;       shim45,  
            btfss       INDF,0          ; 4  5.
            bcf         shim45,4        ;  shim45  2   
                                        ; 
            btfsc       INDF,1
            bsf         shim45,5
            btfss       INDF,1
            bcf         shim45,5           
            
            bcf         STATUS,C
            rrf         INDF,F          ;      2 ,
            bcf         STATUS,C          
            rrf         INDF,F          ;    6   
            movf        shim45,W        ;c 
            movwf       CCP1CON         ; 2      
            movf        INDF,W          ; 6      
            movwf       CCPR1L

            movf        FSR,W           ;     2-  ?
            xorlw       0x6F            ;  ,    
            btfsc       STATUS,Z        ;  FSR     exxit
            goto        bnk2end         ;     2- , 
            incf        FSR,F           ;   
            goto        exxit

ustbnk2     movlw       0x20            ;   2-    
            movwf       FSR             ; 
            bsf         flag,3          ;  1    2- 
            goto        bnk2
 
bnk2end     bcf         flag,2          ;   
            bcf         flag,3          ;    2-  
            goto        exxit

bnk3        btfss       flag,4          ;    3- 
            goto        ustbnk3         ; =1,      
                                        ; =0,    ustbnk3,   
                                        ;  3- 




            
bnk33       btfsc       INDF,0          ; 2   (0  1 )   
            bsf         shim45,4        ;       shim45,  
            btfss       INDF,0          ; 4  5.
            bcf         shim45,4        ;  shim45  2   
                                        ; 

            btfsc       INDF,1
            bsf         shim45,5
            btfss       INDF,1
            bcf         shim45,5           

            bcf         STATUS,C
            rrf         INDF,F          ;      2 ,
            bcf         STATUS,C          
            rrf         INDF,F          ;    6   
            movf        shim45,W        ;c 
            movwf       CCP1CON         ; 2      
            movf        INDF,W          ; 6      
            movwf       CCPR1L

            movf        FSR,W           ;     3-  ?
            xorlw       0xEF            ;  ,    
            btfsc       STATUS,Z        ;  FSR     exxit
            goto        bnk3end         ;     3- , 
            incf        FSR,F           ;   
            goto        exxit

ustbnk3     movlw       0xA0            ;   3-    
            movwf       FSR             ; 
            bsf         flag,4          ;  1    3- 
            goto        bnk33
 
bnk3end     bsf         flag,2          ;  1   
            bcf         flag,4          ;    3-  

exxit       bcf         T1CON,TMR1ON    ;  TMR1
            bcf         PIR1,TMR1IF     ;   .  TMR1
            movlw       0xFE            ;     TMR1
            movwf       TMR1H
            movlw       0xFA
            movwf       TMR1L
            bsf         T1CON,TMR1ON    ;  TMR1

            movf        FSR,W           ;   FSR,  
            movwf       FSRtmp          ;      
            movf        FSR_temp,W       ;
            movwf       FSR

            swapf       STATUS_temp,W   ;  STATUS  W
            movwf       STATUS
            swapf       W_temp,F
            swapf       W_temp,W
            retfie                      ;   
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 

Start       movlw       .0
            movwf       PORTB
            movlw       b'01100000'
            movwf       PORTA
            movlw       0x07
            movwf       CMCON

            bsf         STATUS,RP0        
            movlw       b'00111111'          
            movwf       TRISB
            movlw       b'11110000'          
            movwf       TRISA
            bcf         STATUS,RP0

            movlw       .0
            movwf       T1CON
            bcf         PIR1,TMR1IF     ;    TMR1
            bcf         INTCON,PEIE      ; .  . 

            bsf         STATUS,RP0      
            bsf         PIE1,TMR1IE     ;. .  TMR1          

            movlw       0x3F
            movwf       PR2             ;  
            bcf         STATUS,RP0

            movlw       .0              ; , 
            movwf       CCPR1L          ; =0           
            bsf         STATUS,RP0                    
            bcf         TRISB,3         ;   
            bcf         STATUS,RP0
            movlw       b'00000100'    ;   TMR2
            movwf       T2CON
            movlw       b'00001100'     ;. CCP1   
            movwf       CCP1CON
            
            movlw       b'00001100'
            movwf       shim45
            bcf         flag1,2        ;  .   . 
            bcf         flag1,3        ;  .   . 
            bsf         INTCON,GIE     ;. . .

            btfsc       sel
            goto        pleer
            bcf         flag1,4    
            bsf         STATUS,RP0
            bcf         OPTION_REG,INTEDG
            bcf         STATUS,RP0
pov12       bcf         INTCON,INTF
            bsf         INTCON,INTE
            
            

            SLEEP
            nop 
            bsf         ledini 
            bsf         vdd 
            bsf         CS
            bsf         STATUS,RP1 
            movlw       .4
            call        paus                 
            call        resinit
            btfss       flag1,5
            goto        began
            call        errzvuk
zvon1       bcf         DO
            bcf         CLK 
            bcf         STATUS,RP1
            bcf         vdd
            bsf         STATUS,RP1
            movlw       .2
            call        paus
            bcf         STATUS,RP1
            bcf         ledini
            goto        pov12

pleer       bsf         flag1,4         ;   
pleer1      bsf         vdd             ; 
            bsf         CS
            bsf         STATUS,RP1 
            movlw       .4
            call        paus                 
            call        resinit                                       
            btfss       flag1,5
            goto        began1
            bcf         DO
            bcf         CLK 
            bcf         STATUS,RP1
            bcf         vdd             ; 
            bsf         STATUS,RP1
            movlw       .4
            call        paus
            bcf         STATUS,RP1
            bsf         vdd             ; 
            bsf         CS
            bsf         STATUS,RP1 
            movlw       .4
            call        paus                 
            call        resinit                                       
            btfss       flag1,5
            goto        began1
            bcf         DO
            bcf         CLK 
            bcf         STATUS,RP1
            bcf         vdd              ; 
            bsf         STATUS,RP1
            call        errzvuk
jj1         call        paus500
            goto        jj1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;         
                       
       

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

began1      bcf          STATUS,RP1
            bsf          ledini           
            bsf          STATUS,RP1
            call         pausled
            bcf          STATUS,RP1
            bcf          ledini           
            bsf          STATUS,RP1

began        movlw       data1
             movwf       FSR
             movlw       .3
             movwf       AdrLL
             call        CMD16
             clrf        AdrLL
             call        CMD17
             call        PriemSPI
             movwf       INDF
             incf        FSR,F
             call        PriemSPI
             movwf       INDF
             incf        FSR,F
             call        PriemSPI
             movwf       INDF
             call        PriemSPI
             call        PriemSPI
             movlw       data1
             movwf       FSR
             movlw       0xEB
             xorwf       INDF,W
             btfss       STATUS,Z
             goto        jmpboot
             incf        FSR,F
             incf        FSR,F
             movlw       0x90
             xorwf       INDF,W
             btfsc       STATUS,Z
             goto        PBRboot
             goto        MBRboot
jmpboot      movlw       0xE9
             xorwf       INDF,W
             btfss       STATUS,Z
             goto        MBRboot
PBRboot      movlw       .2
             movwf       AdrLL
             call        CMD16
             goto        PBRboot1

MBRboot      movlw       .2           ;     
             movwf       AdrLL        ;  2 
             call        CMD16
             movlw       .1           ; 2   MBR(  )  
             movwf       AdrLH        ; 001C6   ,   
             movlw       .198         ;   PBR(  )
             movwf       AdrLL        ;  2    AdrLH  AdrHL
             call        CMD17

             call        PriemSPI  
             movwf       AdrLH             
             call        PriemSPI 
             movwf       AdrHL
             
             call        PriemSPI  
             call        PriemSPI 

             bcf         STATUS,C    ;    PBR 
             rlf         AdrLH,F
             rlf         AdrHL,F
PBRboot1     movlw       0xE         ;   PBR  0xE,   
             movwf       AdrLL       ;2 ,     
                                     ;
             
             call        CMD17       ;  2    FATL  FATH
             call        PriemSPI
             movwf       FATL
  
             call        PriemSPI
             movwf       FATH            

             call        PriemSPI
             call        PriemSPI

             bcf         STATUS,C    ; -   
             rlf         FATL,F      ;
             rlf         FATH,F

             movf        AdrLH,W     ;   PBR  -  
             addwf       FATL,F      ;     
             btfss       STATUS,C    ;  FAT
             goto        mett1       ;  FAT    FATL  FATH
             incf        FATH,F
mett1        movf        AdrHL,W
             addwf       FATH,F
            
             movlw       0x16          ;   PBR  0x16,  
             movwf       AdrLL         ;2 ,    -
             call        CMD17         ;  FAT
             call        PriemSPI
             movwf       rootL

             call        PriemSPI
             movwf       rootH
              
             call        PriemSPI
             call        PriemSPI

             bcf         STATUS,C      ;-   FAT       
             rlf         rootL,F       ;  FAT
             rlf         rootH,F
             bcf         STATUS,C      ; -    FAT
             rlf         rootL,F
             rlf         rootH,F

             movf        FATL,W        ;    FAT  - 
             addwf       rootL,F       ;   FAT     
             btfss       STATUS,C      ;   
             goto        mett2         ;       rootL  rootH
             incf        rootH,F
mett2        movf        FATH,W
             addwf       rootH,F
                          
             movlw       0xD           ;   PBR  0x16,  
             movwf       AdrLL         ; ,    - 
             call        CMD17         ; 
             call        PriemSPI
             movwf       Klast         ; -      Klast            

             call        PriemSPI
             call        PriemSPI
             call        PriemSPI

             movlw       .0            ;    FAT16   512
             movwf       datH          ;  32- ,  
             movlw       .64           ;   32 (=512)
             addwf       rootL,W       ;      -
             btfss       STATUS,C      ;      
             goto        mett3         ;  
             incf        datH,F        ;      datL  datH
mett3        movwf       datL
             movf        rootH,W
             addwf       datH,F

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

             movf        Klast,W       ;        
             movwf       AdrLL         ;-   2,    
             movlw       .0            ;,       
             movwf       kol2x
             bcf         STATUS,C
m1           rrf         AdrLL,F
             incf        kol2x,F
             movlw       .0
             xorwf       AdrLL,W
             btfss       STATUS,Z
             goto        m1
             
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

             bcf         flag,0        ;    
             bcf         flag,7        ;    
             clrf        AdrHH         ;  
             clrf        AdrHL          
             clrf        AdrLH
             movlw       .16           ;       16 
             movwf       AdrLL
             call        CMD16

a8           movf        rootH,W       ;     
             movwf       AdrHL         ; 
             movf        rootL,W 
             movwf       AdrLH
             clrf        AdrLL
             clrf        rsec0
             clrf        rsec1

mett7        call        CMD17         ;   
             movlw       .18           ;    18     
             movwf       Sec           ;2  CRC
             movlw       data1         ;     ( 0)
             movwf       FSR           ;   
mett4        call        PriemSPI          ; 18     2  CRC
             movwf       INDF
             incf        FSR,F
             decfsz      Sec,F
             goto        mett4          

             movlw       data1         ;     ( 0)
             movwf       FSR 
            
             movlw       0xE5
             xorwf       INDF,W
             btfsc       STATUS,Z
             goto        mett00           
             movlw       .8            ;   8       
             addwf       FSR,F         ;    
 
             movlw       "W"           ; 3      
             xorwf       INDF,W        ;"WAV",       mett00,  
             btfss       STATUS,Z      ;   
             goto        mett00
             incf        FSR,F
             movlw       "A"
             xorwf       INDF,W
             btfss       STATUS,Z
             goto        mett00
             incf        FSR,F
             movlw       "V"
             xorwf       INDF,W
             btfss       STATUS,Z
             goto        mett00
             bsf         flag,0        ;       
             
             btfss       flag1,4
             goto        a15

             btfss       flag,7        ;   ,  =1
             goto        prod          ;   a15,    
             goto        a15           ; =0    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mett00       movlw       .32           ;     32   
             addwf       AdrLL,F       ;   
             btfss       STATUS,C
             goto        mett6
             movlw       .1
             addwf       AdrLH,F
             btfsc       STATUS,C
             incf        AdrHL,F
mett6        movlw       .1
             addwf       rsec0,F
             btfss       STATUS,C
             goto        d1
             incf        rsec1,F
d1           movlw       .0
             xorwf       rsec0,W       
             btfss       STATUS,Z               
             goto        mett7
             movlw       .2
             xorwf       rsec1,W       
             btfss       STATUS,Z
             goto        mett7
             btfsc       flag,0        ;   ,      
             goto        a8

             bcf         STATUS,RP1
             clrf        CCP1CON            ;(=1),         
             bsf         STATUS,RP1

             movlw       .3
             movwf       Prov1
dd2          movlw       .100
             movwf       Sec1
dd1          bsf         din
             call        paus500
             bcf         din
             call        paus500
             decfsz      Sec1,F
             goto        dd1
             movlw       .100
             movwf       Sec1
dd4          call        paus500
             call        paus500
             decfsz      Sec1,F
             goto        dd4
             decfsz      Prov1,F
             goto        dd2

             movf        rootH,W       ;     
             movwf       AdrHL         ; 
             movf        rootL,W 
             movwf       AdrLH
             clrf        AdrLL
             clrf        rsec0
             clrf        rsec1

             bcf         STATUS,RP1
             movlw       b'00001100'
             movwf       CCP1CON
             bsf         STATUS,RP1

             btfsc       flag1,4 
             goto        prod
             goto        zvon1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mekk7        call        CMD17         ;   
             movlw       .18           ;    18     
             movwf       Sec           ;2  CRC
             movlw       data1         ;     ( 0)
             movwf       FSR           ;   
mekk4        call        PriemSPI          ; 18     2  CRC
             movwf       INDF
             incf        FSR,F
             decfsz      Sec,F
             goto        mekk4          

             movlw       data1         ;     ( 0)
             movwf       FSR 
            
             movlw       0xE5
             xorwf       INDF,W
             btfsc       STATUS,Z
             goto        mek0           
             movlw       .8            ;   8       
             addwf       FSR,F         ;    
 
             movlw       "W"           ; 3      
             xorwf       INDF,W        ;"WAV",       mett00,  
             btfss       STATUS,Z      ;   
             goto        mek0
             incf        FSR,F
             movlw       "A"
             xorwf       INDF,W
             btfss       STATUS,Z
             goto        mek0
             incf        FSR,F
             movlw       "V"
             xorwf       INDF,W
             btfss       STATUS,Z
             goto        mek0
        
             
             
             btfss       flag,7        ;   ,  =1
             goto        prod          ;   a15,    
             goto        a15           ; =0    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mek0         movlw       .0
             xorwf       rsec0,W       
             btfss       STATUS,Z            
             goto        mek1
             movlw       .0
             xorwf       rsec1,W       
             btfsc       STATUS,Z            
             goto        mett7
mek1         movlw       .32           ;     32  
             subwf       AdrLL,F       ;   
             btfsc       STATUS,C
             goto        mek2
             movlw       .1
             subwf       AdrLH,F
             btfss       STATUS,C
             decf        AdrHL,F
mek2         movlw       .1
             subwf       rsec0,F
             btfsc       STATUS,C
             goto        mekk7
             decf        rsec1,F
             goto        mekk7
             
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 

prod         btfsc       next           ;  next ( )
             goto        pp1
             
pp2          call        pausknp
             btfss       next
             goto        pp2
             goto        mett00

pp1          btfsc       back           ;  back ( )
             goto        pp3

pp4          call        pausknp
             btfss       back
             goto        pp4
             goto        mek0
             
pp3          btfsc       play           ;  play ( )
             goto        prod           ;    
             
             btfss       flag,0
             goto        mett00
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

          
             
a15          movf        AdrLL,W        ;   
             movwf       zapLL
             movf        AdrLH,W
             movwf       zapLH
             movf        AdrHL,W
             movwf       zapHL

             clrf        AdrHH          ;  
             clrf        AdrHL          
             clrf        AdrLH
             movlw       .2            ;      
             movwf       AdrLL          ; 2 
             call        CMD16

             movf        zapHL,W        ;   
             movwf       AdrHL
             movf        zapLH,W
             movwf       AdrLH
             movf        zapLL,W
             movwf       AdrLL

             movlw       0x1A           ;  0x1A     
             addwf       AdrLL,F        ;      
             btfss       STATUS,C       ;
             goto        mett10
             movlw       .1
             addwf       AdrLH,F
             btfsc       STATUS,C
             incf        AdrHL,F
mett10       call        CMD17          ;     (2 )
             call        PriemSPI           ;      
                                        ;firstklL  firstklH
             movwf       firstklL
             movwf       LH
             call        PriemSPI
             movwf       firstklH
             movwf       HL
             call        PriemSPI
             call        PriemSPI

             call        klstadress     ;     

             clrf        AdrHH          ;  
             clrf        AdrHL          
             clrf        AdrLH
             movlw       .64            ;      
             movwf       AdrLL          ; 64 
             call        CMD16
             movf        HH,W           ;       
             movwf       AdrHH          ;
             movf        HL,W
             movwf       AdrHL
             movf        LH,W
             movwf       AdrLH
             clrf        AdrLL
             call        CMD17
             movlw       .66            ;    66   
             movwf       Sec            ;2  CRC
             movlw       data1          ;     ( 1)
             movwf       FSR
a10          call        PriemSPI           ; 66    1-  ,  
                                        ;2  CRC
             movwf       INDF
             incf        FSR,F
             decfsz      Sec,F
             goto        a10

             movlw       data1          ;     ( 1)
             movwf       FSR
             bcf         flag,1         ;    
             movlw       "R"            ;  "RIFF"
             call        waverr
             incf        FSR,F
             movlw       "I"
             call        waverr
             incf        FSR,F
             movlw       "F"
             call        waverr
             incf        FSR,F
             movlw       "F"
             call        waverr

             movlw       .5             ;  "WAVE"
             addwf       FSR,F
             movlw       "W"       
             call        waverr
             incf        FSR,F
             movlw       "A"
             call        waverr
             incf        FSR,F
             movlw       "V"
             call        waverr
             incf        FSR,F
             movlw       "E"
             call        waverr

             movlw       .9             ;  = 1
             addwf       FSR,F
             movlw       .1         
             call        waverr

             movlw       .2             ;  = 1
             addwf       FSR,F
             movlw       .1
             call        waverr

             movlw       .2             ;   = 16 
             addwf       FSR,F
             movlw       0x80
             call        waverr
             incf        FSR,F
             movlw       0x3E
             call        waverr

             movlw       .9             ;  = 8 
             addwf       FSR,F
             movlw       .8
             call        waverr

             movlw       .2             ;  "data"
             addwf       FSR,F
             movlw       "d"       
             call        waverr
             incf        FSR,F
             movlw       "a"
             call        waverr
             incf        FSR,F
             movlw       "t"
             call        waverr
             incf        FSR,F
             movlw       "a"
             call        waverr

             incf        FSR,F
             movf        INDF,W
             movwf       sizeLL
            
             incf        FSR,F
             movf        INDF,W
             movwf       sizeLH
           
             incf        FSR,F
             movf        INDF,W
             movwf       sizeHL
            
             incf        FSR,F
             movf        INDF,W
             movwf       sizeHH
        

             btfss       flag,1         ;    ,  =1  
             goto        playwav        ;     
               

             clrf        AdrHH          ;  
             clrf        AdrHL          
             clrf        AdrLH
             movlw       .16            ;       16 
             movwf       AdrLL
             call        CMD16
 
             movf        zapHL,W        ;   
             movwf       AdrHL
             movf        zapLH,W
             movwf       AdrLH
             movf        zapLL,W
             movwf       AdrLL

             bcf         STATUS,RP1
             clrf        CCP1CON
             bsf         STATUS,RP1
 
             movlw       .2
             movwf       Prov1
mm2          movlw       .255
             movwf       Sec1
mm1          bsf         din
             call        paus500
             bcf         din
             call        paus500
             decfsz      Sec1,F
             goto        mm1
             decfsz      Prov1,F
             goto        mm2

             bcf         STATUS,RP1
             movlw       b'00001100'
             movwf       CCP1CON
             bsf         STATUS,RP1
             goto        mett00           

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

          


playwav      clrf        AdrHH          ;      
             clrf        AdrHL          ; 512 
             movlw       .2
             movwf       AdrLH
             clrf        AdrLL
             call        CMD16

             movlw       .44            ;     44   
             movwf       Sec
             movf        Klast,W
             movwf       kolsek         ;    -   

             movf        HH,W           ;       
             movwf       AdrHH
             movf        HL,W
             movwf       AdrHL
             movf        LH,W
             movwf       AdrLH
             clrf        AdrLL
             
             call        CMD18          ;   

b1           call        PriemSPI           ;  44  ,      ,
                                        ;  ,  ,     
             decfsz      Sec,F          ; 
             goto        b1
             movlw       .212           ;    512-    
             movwf       Sec0           ;   44 
             movlw       .2
             movwf       Sec1
             
             
                                      
             movlw       0x20           ;   2-    
             movwf       FSR            ; 

b3           call        PriemSPI
             movwf       INDF           ;  
 
             call        decsiz
             btfss       flag1,0
             goto        x1
             call        comCMD12
             goto        endwav

x1           decf        Sec0,F         ;  512-   
             movf        FSR,W          ;     2-  ?
             xorlw       0x6F           ;  ,    
             btfsc       STATUS,Z       ;   2- 
             goto        b2             ;     2- ,  
             incf        FSR,F          ;   3-  
             goto        b3

b2           movlw       0xA0           ;   3-   
             movwf       FSR            ; 

b5           call        PriemSPI
             movwf       INDF           ;  

             call        decsiz
             btfss       flag1,0
             goto        x2
             call        comCMD12
             goto        endwav 
           
x2           decf        Sec0,F         ;  512-   
             movf        FSR,W          ;     3-  ?
             xorlw       0xEF           ;  ,    
             btfsc       STATUS,Z       ;   3- 
             goto        b4             ;     3- , 
             incf        FSR,F          ;      
             goto        b5             ;   
 
b4           bsf         flag,2         ;    (1- 
                                        ;  2-  , 0-  
                                        ; 3-   
             bcf         flag,3         ;     2-   
                                        ; (0- , 1- )
             bcf         flag,4         ;     3-   
                                        ; (0- , 1- )
             bcf         STATUS,RP1

             movlw       0xFE           ;    TMR1
             movwf       TMR1H
             movlw       0xF4
             movwf       TMR1L
             bcf         PIR1,TMR1IF    ;     . TMR1
             bcf         INTCON,INTF    ;   . INT   
             bsf         INTCON,PEIE    ;. .  . 
             
             bsf         T1CON,TMR1ON   ; TMR1
             
             bsf         STATUS,RP1


b13          bsf         flag,5         ;     (1- 
                                        ;2- , 0-  3- ) 

b6           btfsc       flag,2         ;    
             goto        b6

             movlw       0x20           ;   2-    
             movwf       FSR            ; 
             
b10          call        PriemSPI
             movwf       INDF           ;  

             call        decsiz
             btfss       flag1,0
             goto        x3
             call        comCMD12
             goto        endwav
          
x3           decfsz      Sec0,F         ;  512-   
             goto        b7             ; 0      
             decfsz      Sec1,F         ; 
             goto        b7             ;  0,      2- 
             goto        bbb8           

b7           movf        FSR,W          ;     2-  ?
             xorlw       0x6F           ;  ,    
             btfsc       STATUS,Z       ;   2- 
             goto        b9             ;     2- , 
             incf        FSR,F          ;     
             goto        b10            

b9           bcf         flag,5         ;     
                                        ;(0-  3- )
b11          btfss       flag,2         ;    
             goto        b11

             movlw       0xA0           ;   3-   
             movwf       FSR            ; 

b14          call        PriemSPI
             movwf       INDF           ;  

             call        decsiz         
             btfss       flag1,0
             goto        x4
             call        comCMD12
             goto        endwav
        
x4           decfsz      Sec0,F         ;  512-   
             goto        b12            ; 0      
             decfsz      Sec1,F         ; 
             goto        b12            ;  0,      3- 
             goto        bbb8           

b12          movf        FSR,W          ;     3-  ?
             xorlw       0xEF           ;  ,    
             btfsc       STATUS,Z       ;   3- 
             goto        b13            ;     3- , 
             incf        FSR,F          ;   b13,     
             goto        b14            ; 


bbb8         call        PriemSPI           ; 2-  CRC
             call        PriemSPI

             btfss       flag1,4
             goto        pp7

             btfss       stop           ;  stop ()
             goto        stopwav

             btfsc       next
             goto        pp5

pp6          call        pausknp
             btfss       next
             goto        pp6
             goto        nextwav

pp5          btfsc       back
             goto        pp7

pp8          call        pausknp
             btfss       back
             goto        pp8
             goto        backwav           
                           
pp7          decfsz      kolsek,F       ;    
             goto        b15            ;  0,    512   
             goto        newklast       ; 
b15          movlw       .0             ; 0,     newklast,   
             movwf       Sec0           ;  
             movlw       .2 
             movwf       Sec1
             call        met33
  
             btfsc       flag,5         ;    
             goto        b7
             goto        b12

newklast     call        comCMD12       ;   .  
             call        FATkls         ;    . 
             btfsc       flag,6         ;    ,  =1  
                                        ;    ,     
                                        ;endwav -       
             goto        endwav         ; =0    klstadress,   
             call        klstadress     ;  
             movf        Klast,W
             movwf       kolsek         ;    -   
             movlw       .0             ;    512-   
             movwf       Sec0           
             movlw       .2 
             movwf       Sec1
 
             clrf        AdrHH          ;      
             clrf        AdrHL          ; 512 
             movlw       .2
             movwf       AdrLH
             clrf        AdrLL
             call        CMD16

             movf        HH,W           ;       
             movwf       AdrHH          ;
             movf        HL,W
             movwf       AdrHL
             movf        LH,W
             movwf       AdrLH
             clrf        AdrLL
             
             call        CMD18          ;   
 
             btfsc       flag,5         ;    
             goto        b7
             goto        b12

endwav       bcf         INTCON,PEIE    ;. .  . 
             bcf         STATUS,RP1
             bcf         T1CON,TMR1ON   ; TMR1
             movlw       .0             ; 0    , 
             movwf       CCPR1L        ;
             bsf         STATUS,RP1

             btfss       flag1,4
             goto        endzvonok

bb2          clrf        AdrHH          ;      
             clrf        AdrHL          ;  16 
             clrf        AdrLH
             movlw       .16
             movwf       AdrLL
             call        CMD16

             movf        zapHL,W        ;   
             movwf       AdrHL
             movf        zapLH,W
             movwf       AdrLH
             movf        zapLL,W
             movwf       AdrLL
            
            
             btfss       flag1,3
             goto        bb1
             bcf         flag,7
             bcf         flag1,3
             goto        prod

bb1          bsf         flag,7
             btfss       flag1,2
             goto        mett00
             bcf         flag1,2
             goto        mek0

stopwav      bcf         INTCON,PEIE
             bcf         STATUS,RP1
             bcf         T1CON,TMR1ON
             movlw       .0
             movwf       CCPR1L
             bsf         STATUS,RP1
             call        comCMD12
             bsf         flag1,3 
             goto        bb2            

nextwav      call        comCMD12
             goto        endwav

backwav      call        comCMD12
             bsf         flag1,2
             goto        endwav

endzvonok    bcf         DO
             bcf         CLK
             bcf         STATUS,RP1   ;  0  
             bcf         vdd  
             bsf         STATUS,RP1
             movlw       .2
             call        paus  
             bcf         STATUS,RP1                            
             bcf         INTCON,INTF
             bsf         INTCON,INTE
             bcf         ledini
             

             SLEEP
             nop
             bsf         ledini 
             bsf         vdd 
             bsf         CS
             bsf         STATUS,RP1 
             movlw       .4
             call        paus                 
             call        resinit
             btfss       flag1,5
             goto        began3
             call        errzvuk
             goto        endzvonok
             
             
                                                    
began3       clrf        AdrHH          ;      
             clrf        AdrHL          ;  16 
             clrf        AdrLH
             movlw       .16
             movwf       AdrLL
             call        CMD16

             movf        zapHL,W        ;   
             movwf       AdrHL
             movf        zapLH,W
             movwf       AdrLH
             movf        zapLL,W
             movwf       AdrLL
             goto        mett00

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   

decsiz       movlw       .1
             subwf       sizeLL,F
             btfsc       STATUS,C
             goto        siz           
             subwf       sizeLH,F
             btfsc       STATUS,C
             goto        siz           
             subwf       sizeHL,F
             btfsc       STATUS,C
             goto        siz
             decf        sizeHH,F
siz          movlw       .0
             xorwf       sizeHH,W
             btfss       STATUS,Z
             goto        exsiz
             movlw       .0
             xorwf       sizeHL,W
             btfss       STATUS,Z
             goto        exsiz
             movlw       .0
             xorwf       sizeLH,W
             btfss       STATUS,Z
             goto        exsiz
             movlw       .0
             xorwf       sizeLL,W
             btfss       STATUS,Z
             goto        exsiz
             bsf         flag1,0
             return
exsiz        bcf         flag1,0
             return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     


resinit     movlw        .10          ; 80 
            movwf        Sec
Povtor1     movlw        .255
            call         SendSPI
            decfsz       Sec,F        
            goto         Povtor1
            bcf          STATUS,RP1
            bcf          CS            ; 
            bsf          STATUS,RP1
            call         paus500
        
            movlw        .255
            movwf        Sec
CMD0        movlw        0x40       ;   (CMD0)   
            movwf        SDcom
            clrf         AdrHH
            clrf         AdrHL          
            clrf         AdrLH
            clrf         AdrLL
            movlw        0x95
            call         Sendcomm 

            
            movlw        .20
            movwf        Prov1  
            

;  R1  
          
Povtor2     call         PriemSPI    ;          
            xorlw        .1         ;   
            btfsc        STATUS,Z   ;
            goto         met19      ;
                                    ;
            decfsz       Prov1,F      ;       
            goto         Povtor2
            decfsz       Sec,F
            goto         CMD0
            bsf          flag1,5
            return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

        
met19       movlw        .200
            movwf        Sec
            movlw        0x41             ;;;   (CMD1)   
            movwf        SDcom
CMD1        movlw        0xFF
            call         Sendcomm
            movlw        .255
            movwf        Prov1

Povtor4     call         PriemSPI
            xorlw        .0
            btfsc        STATUS,Z
            goto         met12

            decfsz       Prov1,F             
            goto         Povtor4
            decfsz       Sec,F
            goto         CMD1
            bsf          flag1,5
            return

met12       bcf          flag1,5
            return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

errzvuk      bcf         STATUS,RP1
             clrf        CCP1CON            ;
             bsf         STATUS,RP1

             movlw       .2
             movwf       Prov1
ff2          movlw       .100
             movwf       Sec1
ff1          bsf         din
             call        paus500
             bcf         din
             call        paus500
             decfsz      Sec1,F
             goto        ff1
             movlw       .100
             movwf       Sec1
ff4          call        paus500
             call        paus500
             decfsz      Sec1,F
             goto        ff4
             decfsz      Prov1,F
             goto        ff2

             bcf         STATUS,RP1
             movlw       b'00001100'
             movwf       CCP1CON
             bsf         STATUS,RP1
             return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;    

FATkls       clrf        AdrHH           ;     
             clrf        AdrHL           ;  2 
             clrf        AdrLH
             movlw       .2              
             movwf       AdrLL           
             call        CMD16

             movf        firstklL,W      ;    FAT,   
             movwf       AdrLL           ;       2
             movf        firstklH,W      ;   2   FAT 
             movwf       AdrLH           ;(4 )
             bcf         STATUS,C
             rlf         AdrLL,F
             rlf         AdrLH,F
             rlf         AdrHL,F

             movf        FATL,W          ;     
             addwf        AdrLH,F        ; FAT
             btfsc        STATUS,C
             incf         AdrHL,F
             movf        FATH,W
             addwf        AdrHL,F
             call         CMD17

             call        PriemSPI            ;    (2 )
            
             movwf       firstklL
             movwf       LH
             call        PriemSPI
             movwf       firstklH
             movwf       HL

             call        PriemSPI            ; 2-  CRC
             call        PriemSPI

             movf        firstklL,W      ;       
             andlw       0xf8
             xorlw       0xf8
             btfss       STATUS,Z
             goto        nextkl
             movf        firstklH,W
             xorlw       0xff
             btfss       STATUS,Z
             goto        nextkl
             bsf         flag,6          ;  ,      
             return
nextkl       bcf         flag,6          ;   ,  
             return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


                  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                 

  



            


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    

klstadress   movf         kol2x,W        ;  -   2   
             movwf        AdrLL          ;AdrLL   
             clrf         AdrHH
             clrf         HH
             clrf         LL
             movlw        .2             ;    2,   
             subwf        LH,F           ; ,        
             btfss        STATUS,C       ;FAT ,    ,  
             decf         HL,F           ; 0- .    ,     
             bcf          STATUS,C       ;     2.
m4           decfsz       AdrLL,F        ;   (    
             goto         m2             ; , -     AdrLL)
             goto         m3             ;    
m2           rlf          LH,F
             rlf          HL,F
             rlf          HH,F
             goto         m4

m3           rlf          LH,F           ;      -
             rlf          HL,F           ;   
             rlf          HH,F            
            
             movf        datL,W          ;      - 
             addwf       LH,F            ; ,      
             btfss       STATUS,C        ;
             goto        mett13
             movlw       .1
             addwf       HL,F
             btfss       STATUS,C
             goto        mett13
             incf        HH,F
mett13       movf        datH,W
             addwf       HL,F
             BTFSC       STATUS,C
             incf        HH,F
             return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
             
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PriemSPI     movlw      .8
             movwf      scetbit
povtor3      bcf        CLK
             rlf        perem,F
             bsf        CLK
             btfsc      DI
             bsf        perem,0
             btfss      DI
             bcf        perem,0          
             decfsz     scetbit,F
             goto       povtor3
             movf       perem,W
             return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;             
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 

SendSPI      movwf      perem
             movlw      .8
             movwf      scetbit
povtor       bcf        CLK
             btfsc      perem,7
             bsf        DO
             btfss      perem,7
             bcf        DO
             bsf        CLK
             rlf        perem,F
             decfsz     scetbit,F
             goto       povtor
             return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   WAV 

waverr      xorwf       INDF,W
            btfss       STATUS,Z
            bsf         flag,1
            return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;      (CMD16)   
 
CMD16       movlw       .5              
            movwf       Sec3
            movlw       0x50             
            movwf       SDcom            
cmd16a      movlw       0xFF
            call        Sendcomm
            movlw       .15
            movwf       Prov1
met5        call        PriemSPI
                     
            xorlw        .0
            btfsc        STATUS,Z
            return

            decfsz     Prov1,F             
            goto       met5
             
            decfsz     Sec3,F             
            goto       cmd16a
            goto       errorcmd 

 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;    (CMD17)   

CMD17       movlw       .3              
            movwf       Sec2
            movlw       .5              
            movwf       Sec3
            movlw       0x51              
            movwf       SDcom              
cmd17a      movlw       0xFF
            call        Sendcomm
            movlw       .15
            movwf       Prov1
met6        call        PriemSPI
            
            xorlw        .0
            btfsc        STATUS,Z
            goto         met33
            
            decfsz     Prov1,F             
            goto       met6
             
            decfsz     Sec3,F             
            goto       cmd17a
            goto       errorcmd
            

met33       movlw       .255
            movwf       Prov1
met55       call        PriemSPI
 
            xorlw        .254
            btfsc        STATUS,Z
            return
            decfsz     Prov1,F             
            goto       met55
            
            decfsz     Sec2,F             
            goto       cmd17a
            goto       errorcmd
            
             
             



;;;;;;;    ;;;;;;;;;;;   ;;;;;;;;;   ;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;    (CMD18)   

CMD18       movlw       .3              
            movwf       Sec2
            movlw       .5              
            movwf       Sec3
            movlw       0x52             
            movwf       SDcom             
cmd18a      movlw       0xFF
            call        Sendcomm
            movlw       .15
            movwf       Prov1

merka6      call        PriemSPI

            xorlw        .0
            btfsc        STATUS,Z
            goto         met44
          
            decfsz     Prov1,F             
            goto       merka6
             
            decfsz     Sec3,F             
            goto       cmd18a
            goto       errorcmd


met44       movlw       .255
            movwf       Prov1
met75       call        PriemSPI
            xorlw        .254
            btfsc        STATUS,Z
            return
            decfsz     Prov1,F             
            goto       met75

            decfsz     Sec2,F             
            goto       cmd18a
            goto       errorcmd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;    

comCMD12    movlw       .2              
            movwf       Sec2
            movlw       .5              
            movwf       Sec3
            
            movlw       0x4C             
            movwf       SDcom            
            clrf        AdrHH
            clrf        AdrHL       
            clrf        AdrLH         
            clrf        AdrLL
CMD12       movlw       0xFF
            call        Sendcomm
            movlw       .15
            movwf       Prov1

met34       call        PriemSPI

            xorlw        .0
            btfsc        STATUS,Z
            goto         met35

            decfsz     Prov1,F             
            goto       met34     
            decfsz     Sec3,F             
            goto       CMD12
            goto       errorcmd
 
 
met35       movlw       .2              
            movwf       Sec4
met29       movlw       .255
            movwf       Prov1
met28       call        PriemSPI
            xorlw        .255
            btfsc        STATUS,Z
            return
            decfsz     Prov1,F             
            goto       met28
            decfsz     Sec4,F             
            goto       met29

            decfsz     Sec2,F             
            goto       CMD12
            goto       errorcmd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;

errorcmd     bcf         INTCON,PEIE    ;. .  . 
             bcf         STATUS,RP1
             bcf         T1CON,TMR1ON   ; TMR1
             movlw       .0             ; 0    , 
             movwf       CCPR1L        ;
             bsf         STATUS,RP1

             btfss       flag1,4        ;  (  )
             goto        zvonprov

             bcf         DO
             bcf         CLK 
             bcf         STATUS,RP1
             bcf         vdd             ; 
             bsf         STATUS,RP1
             movlw       .4
             call        paus
             bcf         STATUS,RP1
             goto        pleer1


zvonprov     btfss       flag,0
             goto        zvon1
             goto        endzvonok











            

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;      

Sendcomm     movwf      SDcrc
             movlw      .255
             call       SendSPI
             movlw      .255
             call       SendSPI
             movf       SDcom,W
             call       SendSPI
             movf       AdrHH,W
             call       SendSPI
             movf       AdrHL,W
             call       SendSPI
             movf       AdrLH,W
             call       SendSPI
             movf       AdrLL,W
             call       SendSPI
             movf       SDcrc,W
             call       SendSPI
             return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;' 



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     

paus500      movlw       .4
             movwf       Sec0           
pap2         movlw       .208
             movwf       Sec
pap1         decfsz      Sec,F
             goto        pap1
             decfsz      Sec0,F
             goto        pap2
             return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    

pausknp      movlw       .7
             movwf       Sec
kn2          movlw       .255
             movwf       Sec0
kn1          decfsz      Sec0,F
             goto        kn1
             decfsz      Sec,F 
             goto        kn2
             return

pausled      movlw       .10
paus         movwf       Sec0
pld3         movlw       .160
             movwf       Sec1           
pld2         movlw       .255
             movwf       Sec
pld1         decfsz      Sec,F
             goto        pld1
             decfsz      Sec1,F
             goto        pld2
             decfsz      Sec0,F
             goto        pld3
             return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

            END

;  WAV   ,    
;        .    
;   ,  0-  1-  ,   80   
;,       160 .     
; ,    78,12    20,    
;   8 ,    8  WAV .    
;,    2       CCP1CON,  
;6      CCPR1L,     .   
;     WAV     ,  
;    16-   TMR1,       
; WAV .  ,    ,  
;      TMR1   ,   16- .  
;  ""          SB1, 
;     INT.   ""   . 
;   :      SB1,  0-  
; 64  WAV ,     ,   WAV ,   
; ,    WAV     44 
;  .     0- ,   80 , 
;  1- ,  80 ,     TMR1,  
;  ,     0-      ,   
;    0- ,      
; 80  0- ,       1-  ,  0- 
;,           ,     
;     1- ,      
;80  0- ,     1- ,    , 
;   0- ,      1- ,   
;  .         . 


             







